﻿using System.Reflection;

namespace EDPlayerJournal.Entries {
    public class PowerplayEntry : Entry {
        /// <summary>
        /// Name of the power
        /// </summary>
        public string Power { get; set; } = string.Empty;

        /// <summary>
        /// Player rank
        /// </summary>
        public int Rank { get; set; } = 0;

        /// <summary>
        /// Current merits of the player
        /// </summary>
        public long Merits { get; set; } = 0;

        /// <summary>
        /// Time pledged (in seconds?)
        /// </summary>
        public long TimePledged { get; set; } = 0;

        protected override void Initialise() {
            Power = JSON.Value<string>("Power") ?? string.Empty;
            Rank = JSON.Value<int?>("Rank") ?? 0;
            Merits = JSON.Value<long?>("Merits") ?? 0;
            TimePledged = JSON.Value<long?>("TimePledged") ?? 0;
        }
    }
}
